﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using SuperMap.Desktop;
using SuperMap.Realspace;
using SuperMap.UI;
using SuperMap.Data;

namespace SuperMap.Desktop.Samples
{
    class _CtrlActionLower : CtrlAction
    {
        public _CtrlActionLower(IBaseItem caller)
            : base(caller)
        {

        }
        override public void Run()
        {
            _Toolkit.changeHeight(-10); //Reduce 10 meters
        }
        public override bool Enable()
        {
            Boolean enable = false;
            try
            {
                IFormScene formScene = SuperMap.Desktop.Application.ActiveForm as IFormScene;
                SceneControl sceneControl = formScene.SceneControl;
                Selection3D[] selection3Ds = sceneControl.Scene.FindSelection(true);
                Selection3D selection = null;
                if (selection3Ds.Length == 1)
                {
                    selection = selection3Ds[0];
                }
                if (selection.Layer.Type == Layer3DType.Dataset && (selection.Layer as Layer3DDataset).Dataset.Type==DatasetType.Region)
                {
                    Theme3D themeType = (selection.Layer as Layer3DDataset).Theme;
                    if ((themeType is Theme3DUnique) || (themeType is Theme3DRange))
                    {
                        enable = true;
                    }
                    Layer3DSettingVector layer3DSettingVector = (selection.Layer as Layer3DDataset).AdditionalSetting as Layer3DSettingVector;
                    if (layer3DSettingVector.Style.AltitudeMode != AltitudeMode.ClampToGround)
                    {
                        enable = true;
                    }
                }
            }
            catch
            {
            }
            return enable;
        }
    }
}
